﻿using CISPLBulkSMS;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace BulkSMSDemo
{
    public partial class Form1 : Form
    {
        private SMSSettings bulkSMSSetting = new SMSSettings();

        private BulkSMS ctlBulkSMS = new BulkSMS();
        public Form1()
        {
            InitializeComponent();
            //Load SMS Setting from permanent store - we have used JSON for example - you may use any DB
            LoadSmsSetting();
            //Alternatively, properties of UC may be directly assigned by sms generating application.
            //ctlBulkSMS.SmsHostName = "www.smsnmms.co.in";
            //ctlBulkSMS.SmsHostUserID = "mybsuserid@myemail.com";
            //ctlBulkSMS.RememberUserID = true;
            //ctlBulkSMS.SmsHostPassword = "mysmsaccountpassword";
            //ctlBulkSMS.RememberPwd = false;
            //ctlBulkSMS.MobileNos = "910123456789,910123456789";
            //ctlBulkSMS.SmsText = "Last typed text in SMS Textbox";
            //ctlBulkSMS.AppendTextToSms = true;
            //ctlBulkSMS.AppendSmsText = "My SMS Signature";
            //ctlBulkSMS.LoginPanelExpanded = true;
            //ctlBulkSMS.SmsSenderID = "BLKSMS";       //will work only in case dynamic sender id enabled for Ac
            ////ctlBulkSMS.SMSSchedule = DateTime.Now.AddMinutes(10);   //Normally left unassigned to submit sms immediately
            //ctlBulkSMS.SMSTemplates = new ObservableCollection<SMSSettings.SMSTemplateItem>()
            //{
            //    new SMSSettings.SMSTemplateItem {Name = "Invoice Alert", SMSText = "Your Invoice has been created and mailed to you."},
            //    new SMSSettings.SMSTemplateItem {Name = "Dispatch Alert", SMSText = "Your Material has been dispatched." },
            //    new SMSSettings.SMSTemplateItem {Name = "Credit Note", SMSText = "Your Credit Note has been created and mailed to you." }
            //};
            //Since Bulk SMS Control in developed using WPF, it needs to be displayed using ElementHost control
            WPFElementHost.Child =  ctlBulkSMS;
        }

        private void btnProperty_Click(object sender, EventArgs e)
        {
            ctlBulkSMS.CountSMSCharaters();
            txtSmsDetail.Text = "Unicode: " + ctlBulkSMS.SmsIsUnicode.ToString()
                              + " Length: " + ctlBulkSMS.SmsTextLen.ToString()
                              + " Segments: " + ctlBulkSMS.SmsNoOfSegments.ToString();

            ctlBulkSMS.ProcessMobileNo();
            txtSmsDetail.Text += " Mobile Nos. Count: " + ctlBulkSMS.PhoneNosCount.ToString();
        }


        public void SaveAPISetting()
        {
            string FileName = "SmsSetting.json";

            bulkSMSSetting.SmsHostName = ctlBulkSMS.SmsHostName;
            bulkSMSSetting.SmsHostUserID = ctlBulkSMS.SmsHostUserID;
            bulkSMSSetting.RememberUserID = ctlBulkSMS.RememberUserID;
            bulkSMSSetting.SmsHostPassword = ctlBulkSMS.SmsHostPassword;
            bulkSMSSetting.RememberPwd = ctlBulkSMS.RememberPwd;
            bulkSMSSetting.LastSmsText = ctlBulkSMS.SmsText;
            bulkSMSSetting.AppendTextToSms = ctlBulkSMS.AppendTextToSms;
            bulkSMSSetting.AppendSmsText = ctlBulkSMS.AppendSmsText;
            bulkSMSSetting.LoginPanelExpanded = ctlBulkSMS.LoginPanelExpanded;
            bulkSMSSetting.SmsSenderID = ctlBulkSMS.SmsSenderID;
            bulkSMSSetting.lstTemplates = ctlBulkSMS.SMSTemplates;
            //Save ApiSetting in Json File
            File.WriteAllText(FileName, JsonConvert.SerializeObject(bulkSMSSetting, Formatting.Indented));

            //ctlBulkSMS
        }


        private void LoadSmsSetting()
        {
            //Read Settings from Json File
            string FileName = "SmsSetting.json";
            if (File.Exists(FileName))
            {
                bulkSMSSetting = JsonConvert.DeserializeObject<SMSSettings>(File.ReadAllText(FileName));
                ctlBulkSMS.SmsHostName = bulkSMSSetting.SmsHostName;
                ctlBulkSMS.SmsHostUserID = bulkSMSSetting.SmsHostUserID;
                ctlBulkSMS.RememberUserID = bulkSMSSetting.RememberUserID;
                ctlBulkSMS.SmsHostPassword = bulkSMSSetting.SmsHostPassword;
                ctlBulkSMS.RememberPwd = bulkSMSSetting.RememberPwd;
                ctlBulkSMS.SmsText = bulkSMSSetting.LastSmsText;
                ctlBulkSMS.AppendTextToSms = bulkSMSSetting.AppendTextToSms;
                ctlBulkSMS.AppendSmsText = bulkSMSSetting.AppendSmsText;
                ctlBulkSMS.LoginPanelExpanded = bulkSMSSetting.LoginPanelExpanded;
                ctlBulkSMS.SmsSenderID = bulkSMSSetting.SmsSenderID;
                ctlBulkSMS.SMSTemplates = bulkSMSSetting.lstTemplates;
            }
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            SaveAPISetting();
        }

        private async void btnSubmit_Click(object sender, EventArgs e)
        {
            await ctlBulkSMS.submitSMS();
        }
    }
}
